// Try to print the cmdlines of all process spawns by polling /proc.

#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <dirent.h>
#include <stdio.h>


static unsigned int active[65536];

// assumes that *str can't be empty
static int str_to_int(char *str) {
  unsigned int res = 0;
  while (1) {
    if (*str < '0' || *str > '9') return -1;
    res += *str - '0';
    str++;
    if (*str == '\0') return res;
    res *= 10;
  }
}

int main(int argc, char *argv[]) {
  for (int i=0; i<65536; i++) {
    active[i] = 0;
  }
  
  chdir("/proc");
  DIR *dir = opendir(".");
  unsigned int cycle = 2, lastcycle;
  while (1) {
    lastcycle = cycle-1;
    struct dirent *dent;
    char path[5+1+7+1];
    while ((dent = readdir(dir)) != NULL) {
      int name_id = str_to_int(dent->d_name);
      if (name_id < 0 || name_id > 65535) continue;
      if (active[name_id] != lastcycle) {
        sprintf(path, "%s/cmdline", dent->d_name);
        int fd = open(path, O_RDONLY);
        if (fd != -1) {
          char cmdline[65536];
          int cmdline_len = read(fd, cmdline, 65536);
          if (cmdline_len != -1) {
            write(1, cmdline, cmdline_len);
            write(1, "\n", 1);
          }
          close(fd);
        }
      }
      active[name_id] = cycle;
    }
    rewinddir(dir);
    cycle++;
  }
}
